<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require_once("./functions.php");
html_start("SpamAssassin Lint");

if(!$fp = popen('/usr/bin/spamassassin -x -D -p /etc/MailScanner/spam.assassin.prefs.conf --lint 2>&1','r')) {
 die("Cannot open pipe"); 
}

echo "<TABLE CLASS=\"mail\" WIDTH=\"100%\">\n";
echo " <THEAD>\n";
echo "  <TH COLSPAN=2>SpamAssassin Lint</TH>\n";
echo " </THEAD>\n";
// Start timer
$start = get_microtime();
$last = false;
while($line = fgets($fp,2096)) {
 $line = eregi_replace("\n","",$line);
 if($line !== "" && $line !== " ") { 
  $timer = get_microtime();
  $linet = $timer-$start;
  if(!$last) { $last = $linet; }
  echo "<!-- Timer: $timer, Line Start: $linet -->\n";
  echo "    <TR>\n";
  echo "     <TD>$line</TD>\n";
  $this = $linet-$last;
  $last = $linet;
  if($this>=2) {
   echo "     <TD CLASS=\"lint_5\">".round($this,5)."</TD>\n";
  } elseif($this>=1.5) {
    echo "     <TD CLASS=\"lint_4\">".round($this,5)."</TD>\n";
  } elseif($this>=1) {
    echo "     <TD CLASS=\"lint_3\">".round($this,5)."</TD>\n"; 
  } elseif($this>=0.5) {
    echo "     <TD CLASS=\"lint_2\">".round($this,5)."</TD>\n";
  } elseif($this<0.5) {
    echo "     <TD CLASS=\"lint_1\">".round($this,5)."</TD>\n";
  }
  echo "    </TR>\n";
 }
}
pclose($fp);
echo "   <TR>\n";
echo "    <TD><B>Finish - Total Time<B></TD>\n";
echo "    <TD ALIGN=\"RIGHT\"><B>".round(get_microtime()-$start,5)."</B></TD>\n";
echo "   </TR>\n";
echo "</TABLE>\n";

html_end();
?>
