#!/usr/bin/php4 -q
<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Edit this to reflect the full path to functions.php
require("/usr/share/mailwatch/functions.php");

function doit($input) {
 global $fp;
 if(!$fp = popen($input,'r')) {
  die("Cannot open pipe"); 
 }

 // Which host are we running on??
 $hostname = gethostbyaddr('127.0.0.1');

 while($line = fgets($fp,2096)) {
  // Only interested in sendmail log lines
  // If it matches, split on the Message ID. 
  if(preg_match('/sendmail\[.*\]: (\S+):.+/',$line,$match1)) {
   // Only interested in lines that have both relay= and stat=
   if(preg_match('/\[(\d+\.\d+\.\d+\.\d+)\]/',$match1[0],$match2) && preg_match('/stat=(.+)/', $match1[0],$match3)) {
    $hostname = mysql_escape_string($hostname);
    $messageid = mysql_escape_string($match1[1]);
    $relay = mysql_escape_string($match2[1]);
    $stat = mysql_escape_string($match3[1]);
    if (DEBUG) { echo 'Host: '.$hostname.', ID: '.$messageid.', Relay: '.$relay.', Status:' .$stat."\n"; }
    $sql = "INSERT INTO relay (msg_id, relay, status, host) VALUES ('$messageid','$relay','$stat','$hostname')";
    $sth = dbquery($sql);
   }
  }
 }
 pclose($fp);
}

if($_SERVER['argv'][1] == "--refresh") {
 doit('cat /var/log/mail.log');
} else {
 // Refresh first
 doit('cat /var/log/mail.log');
 // Start watching the mail.log
 doit('tail -F -n0 /var/log/mail.log');
}

?>
