<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

header("Content-type: text/plain\n\n");
require("./mailscanner/functions.php");

function pad($input) {
 $input = str_pad($input, 70, ".", STR_PAD_RIGHT);
 return $input;
}

// Test connectivity to the database
echo pad("Testing connectivity to the database ");
if(($link = @mysql_connect(DB_HOST,DB_USER,DB_PASS)) && @mysql_select_db(DB_NAME)) {
 echo " OK\n";
 // Update schema at this point
 echo "Updating database schema: \n";
 /*
 **  Updates to the schema for 0.5
 */
 // Create backup of maillog
 echo pad(" - Creating backup of maillog table to maillog_pre");
 $sql = "DROP TABLE maillog_pre";
 @mysql_query($sql); // Don't care if this succeeds or not
 $sql = "CREATE TABLE maillog_pre AS SELECT * FROM maillog";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 // Drop the indexes
 echo (" Dropping all indexes on maillog table:\n");
 $sql = "SHOW INDEX FROM maillog";
 $result = dbquery($sql);
 while($row=mysql_fetch_object($result)) {
  // Use key name as array key to remove dups...
  $indexes[$row->Key_name] = true;
 }
 foreach($indexes as $key=>$val) {
  echo pad(" - Dropping index $key ");
  $sql = "DROP INDEX $key ON maillog";
  if(@mysql_query($sql)) {
   echo " OK\n";
  } else {
   echo " ERROR\n";
   die("MySQL error: ".@mysql_error());
  }
 }
 // Alter the database structure
 echo pad(" - Adding spamblacklisted column to maillog table ");
 $sql = "ALTER TABLE maillog ADD COLUMN spamblacklisted TINYINT(1) DEFAULT '0' AFTER spamwhitelisted";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 echo pad(" - Adding type column to users table ");
 $sql = "ALTER TABLE users ADD COLUMN type enum('A','D','U') NOT NULL default 'A'";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 echo pad(" - Creating index maillog_id_idx ");
 $sql = "CREATE INDEX maillog_id_idx ON maillog(id(20))";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 echo pad(" - Creating index maillog_datetime_idx ");
 $sql = "CREATE INDEX maillog_datetime_idx ON maillog(date,time)";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 echo pad(" - Creating index maillog_to_idx ");
 $sql = "CREATE INDEX maillog_to_idx ON maillog(to_address(255))";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 echo pad(" - Creating index maillog_from_idx ");
 $sql = "CREATE INDEX maillog_from_idx ON maillog(from_address(255))";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 echo pad(" - Creating user_filters table ");
 $sql = "
CREATE TABLE user_filters (
  username varchar(20) NOT NULL default '',
  filter text,
  verify_key varchar(32) NOT NULL default '',
  active enum('N','Y') default 'N',
  KEY user_filters_username_idx (username)
) TYPE=MyISAM
";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
 /*
 ** Updates to the schema for 0.4
 **
 echo pad(" - Creating index maillog_id_idx on maillog id");
 $sql = "CREATE INDEX maillog_id_idx ON maillog(id(20))";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error()."\n");
 }

 echo pad(" - Dropping index 'date_idx'");
 $sql = "DROP INDEX date_idx ON maillog";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error()."\n");
 }

 echo pad(" - Creating new index on maillog table");
 $sql = "CREATE INDEX maillog_datetime_idx ON maillog(date,time)";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error()."\n");
 }
 
 echo pad(" - Creating table 'relay'");
 $sql = "
CREATE TABLE relay (
  id int(11) NOT NULL auto_increment,
  timestamp timestamp(14) NOT NULL,
  msg_id varchar(20) NOT NULL default '',
  relay text,
  status text,
  host text,
  PRIMARY KEY  (id),
  KEY msg_id (msg_id)
) TYPE=MyISAM
";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error()."\n");
 }
 */
 /* 
 ** Updates to the schema for 0.3beta
 **
 // Create backup of maillog
 echo pad(" - Creating backup of maillog table to maillog_pre");
 $sql = "DROP TABLE maillog_pre";
 @mysql_query($sql); // Don't care if this succeeds or not
 $sql = "CREATE TABLE maillog_pre AS SELECT * FROM maillog WHERE 1=0";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }

 // Update maillog
 echo pad(" - Updating table maillog ");
 if(!@mysql_query("ALTER TABLE maillog ADD COLUMN date DATE")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("ALTER TABLE maillog ADD COLUMN time TIME")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("ALTER TABLE maillog ADD COLUMN headers TEXT")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("CREATE INDEX date_idx ON maillog (date)")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("UPDATE maillog SET timestamp=timestamp, date=DATE_FORMAT(timestamp, '%Y-%m-%d'), time=DATE_FORMAT(timestamp, '%H:%i:%s')")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 echo " OK\n";
 
 // Create table inq
 echo pad(" - Creating table 'inq' ");
 $sql = "
CREATE TABLE inq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM ";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }

 // Create table 'outq'
 echo pad(" - Creating table outq ");
 $sql = "
CREATE TABLE outq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }
*/

 // Phew! - finished
 mysql_close($link);
} else {
 echo " FAILED\n";
 $errors[] = "Database connection failed: ".@mysql_error();
}

echo "\n";

// Check MailScanner settings
echo "Checking MailScanner.conf settings: \n";
$check_settings = array(
 'QuarantineWholeMessage' 		=> 'yes',
 'QuarantineWholeMessagesAsQueueFiles' 	=> 'no',
 'DetailedSpamReport' 			=> 'yes',
 'IncludeScoresInSpamAssassinReport' 	=> 'yes',
 'SpamActions' 				=> 'store',
 'HighScoringSpamActions' 		=> 'store',
 'AlwaysLookedUpLast' 			=> '&MailWatchLogging'
);
foreach($check_settings as $setting=>$value) {
 echo pad(" - $setting ");
 if(preg_match('/'.$value.'/',get_conf_var($setting))) {
  echo " OK\n";
 } else {
  echo " WARNING\n";
  $errors[] = "MailScanner.conf: $setting != $value (=".get_conf_var($setting).")";
 }
}
echo "\n";

if(is_array($errors)) {
 echo "*** ERROR/WARNING SUMMARY ***\n";
 foreach($errors as $error) {
  echo $error."\n";
 }
}
