#
# MailWatch for MailScanner
# Copyright (C) 2003  Steve Freegard (smf@f2s.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# 2003-11-27 
# F-Secure status by Carl Boberg modified from Sophos status by Steve Freegard 

BEGIN { 
 FS = ": "; 
 print "<TABLE CLASS=\"SOPHOS\" CELLPADDING=2 CELLSPACING=2>";
 print " <THEAD>";
 print "  <TH COLSPAN=4>F-Secure Information</TH>";
 print " </THEAD>";
}

/F-Secure Anti-Virus Database/||/Copyright/ {
  print " <TR><TD COLSPAN=4>"$1"</TD></TR>";
}

/Frisk/ { 
 print " <TR>";
 print "  <TH COLSPAN=4>"$1"</TH>";
 print " </TR>";
 print " <TR>";
 print "  <TH>File</TH>";
 print "  <TH>Version</TH>";
 print "  <TH>Date</TH>";
 print "  <TH>Status</TH>";
 print " </TR>";
}
/def/ { 
split($1, array, " "); 
 v_name = array[1];
 v_ver = array[2];
 v_date = array[3];
 v_status = array[4];
 print " <TR>";
 print "  <TD>"v_name"</TD>";
 print "  <TD>"v_ver"</TD>";
 print "  <TD>"v_date"</TD>";
 print "  <TD>"v_status"</TD>";
 print " </TR>";
}

/Kaspersky/ {
  print " <TR>";
  print "  <TH COLSPAN=4>"$1"</TH>";
  print " </TR>";
  print " <TR>";
  print "  <TH>File</TH>";
  print "  <TH>Version</TH>";
  print "  <TH>Date</TH>";
  print "  <TH>Status</TH>";
  print " </TR>";
}
/avc/ {
split($1, array, " ");
  v_name = array[1];
  v_ver = array[2]; 
  v_date = array[3];
  v_status = array[4];
  print " <TR>";
  print "  <TD>"v_name"</TD>";
  print "  <TD>"v_ver"</TD>";
  print "  <TD>"v_date"</TD>";
  print "  <TD>"v_status"</TD>";
  print " </TR>";
}
/End of/ {
  print " <TR>";
  print "  <TD COLSPAN=4>"$1"</TD>";
  print " </TR>";
}

/Orion engine/ {
  print " <TR>";
  print "  <TH COLSPAN=4>"$1"</TH>";
  print " </TR>";
  print " <TR>";
  print "  <TH>File</TH>";
  print "  <TH>Version</TH>";
  print "  <TH>Date</TH>";
  print "  <TH>Status</TH>";
  print " </TR>";
}
/DAT/ {
  split($1, array, " ");
  v_name = array[1];
  v_ver = array[2];
  v_date = array[3];
  v_status = array[4];
  print " <TR>";
  print "  <TD>"v_name"</TD>";
  print "  <TD>"v_ver"</TD>";
  print "  <TD>"v_date"</TD>";
  print "  <TD>"v_status"</TD>";
  print " </TR>";
}


#End of DupDestroy
#F-Secure Corporation Orion engine version 1.02 build 25
#ORION.DAT version 2003-11-14 valid


END { print "</TABLE>" }

